REM This file is part of the PiDuce project (http://www.cs.unibo.it/Piduce) developed at the Department of Computer Science of Bologna. Authors: Samuele Carpineti, Cosimo Laneve, Leonardo Mezzina, Luca Padovani

ECHO OFF
ECHO Building PiDuce...

set COMPILER=csc -define:SMART_CORE_MATCHER 
set COMMONSOURCES=Set.cs Pair.cs Cell.cs LabelSet.cs BasicType.cs Type.cs Schema.cs Expression.cs Process.cs SymbolTable.cs XmlUtil.cs Constant.cs AssemblyInfo.cs
set TYPESSOURCES=CorrectenessChecker.cs DeterminednessChecker.cs EmptynessChecker.cs Handle.cs HandleSet.cs SubtypingChecker.cs SchemaChecker.cs AssemblyInfo.cs
set WEBSOURCES=Schema.cs XsdToSchema.cs SchemaToXsd.cs WsdlReader.cs WsdlGenerator.cs AssemblyInfo.cs
set COMPILERSOURCES=AssemblyInfo.cs CompilerOutput.cs SymbolTable.cs Schema.cs Lexer.cs Parser.cs Resolver.cs Checker.cs Compiler.cs Main.cs
set MACHINESOURCES=AssemblyInfo.cs ChannelManager.cs JoinInput.cs MachineOutput.cs Main.cs Scheduler.cs Value.cs ValueUtil.cs SoapHandler.cs Env.cs Schema.cs Expression.cs SymbolTable.cs TypeMap.cs Webutil.cs Matcher.cs
set WSDL2PIDUCESOURCES=Main.cs AssemblyInfo.cs

IF NOT EXIST .\Binaries md .\Binaries

cd Common
%COMPILER% -target:library -out:..\Binaries\common.dll %COMMONSOURCES%

cd ..\Types
%COMPILER% -r:..\Binaries\common.dll -target:library -out:..\Binaries\types.dll %TYPESSOURCES%
 
cd ..\Web
%COMPILER% -r:..\Binaries\common.dll,..\Binaries\types.dll -lib:..\Binaries\ -target:library -out:..\Binaries\web.dll %WEBSOURCES% 

cd ..\Compiler
%COMPILER% -lib:..\Binaries -r:..\Binaries\common.dll,..\Binaries\types.dll,..\Binaries\web.dll -out:..\Binaries\PiDuceCompiler.exe %COMPILERSOURCES%
copy bytecode.xsd ..\Binaries\

cd ..\Machine
%COMPILER% -r:..\Binaries\common.dll,..\Binaries\types.dll,..\Binaries\web.dll -lib:..\Binaries -out:..\Binaries\PiDuceMachine.exe %MACHINESOURCES%
copy machineAbstract.wsdl ..\Binaries
copy PiDuceMachine.exe.MANIFEST ..\Binaries

cd ..\Wsdl2PiDuce
%COMPILER% -lib:..\Binaries -r:..\Binaries\common.dll,..\Binaries\types.dll,..\Binaries\web.dll,..\Binaries\PiDuceCompiler.exe -out:..\Binaries\Wsdl2PiDuce.exe %WSDL2PIDUCESOURCES%

cd ..

ECHO Build succeeded
